package com.findlaypark.codes;

public enum AccessStatus {

	
	PENDING		(0, "New User Pending"),
	ALLOWED		(1, "Access Authorised"),	
	DISALLOWED	(2, "User Disallowed");
	
	
	private int id;
	private String description;
	
	
	AccessStatus(int id, String description) {
		this.id = id;
		this.description = description;
	}
	
	public String getDescription() {
		return description;
	}
	
	public static AccessStatus getReasonCode(int id) {
		for(AccessStatus r : AccessStatus.values()) {
			if(r.id == id) return r;
		}
		return PENDING;
	}
	
	public int getId() {
		return id;
	}
}
