package com.findlaypark.codes;

public enum ReasonCodes {

	UNDEFIND 		(0, "Undefined"),
	HAVE_HOLDINGS 	(1, "Have Current Holdings"), 
	WANT_HOLDINGS 	(2, "Looking to Have Holdings"), 
	OTHER 			(3, "Other"), 
	EMPLOYEE 		(3, "Employee") ;
	
	
	private final String description;
	private final int id;
	
	ReasonCodes(int id, String description) {
		this.id = id;
		this.description = description;
	}
	
	public String getDescription() {
		return description;
	}
	
	public static ReasonCodes getReasonCode(int id) {
		for(ReasonCodes r : ReasonCodes.values()) {
			if(r.id == id) return r;
		}
		return UNDEFIND;
	}
	
	public int getId() {
		return id;
	}
	
}
