package com.findlaypark.db;

import java.sql.Connection;
import java.sql.Driver;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Hashtable;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;


public class DBUtilities {
	
	public static final String REACH_SCHEMA = "DB_REACH";
	public static final String DB_NAME = "DB_REACH";
	public static final String pword = "db2admin";
	private static final String DATASOURCE = "jdbc/stpdatasource";
	
	private static DataSource sds = null;
	
	
	private static DBConfig config;
	
	public static void setup(String configName) {
		DBUtilities.config = new DBConfigDerby();
		/*
		if(configName.equals(Server.DB_ORA)) {
			DBUtilities.config = new DBConfigOra();
		} else if(configName.equals(Server.DB_DERBY)){
			DBUtilities.config = new DBConfigDerby();
			
		}else {
			DBUtilities.config = new DBConfigDB2();
		}
		*/
	}
	

	public static Connection getConnection() throws SQLException, NamingException {
		try {
			return getConnection(DATASOURCE);
		} catch(SQLException e) {
			e.printStackTrace();
			throw e;
		} catch(NamingException e) {
			e.printStackTrace();
			throw e;
		}
	}

	public static Connection getConnection(String lookupName) throws SQLException, NamingException {
		
		return config.getConnection();
	}

	/**
	 * Common call for cleaning up Connection and Statement which is currently
	 * opened.
	 * 
	 * @param con
	 *            the JDBC connection to close
	 * @param stmt
	 *            the Statement to close
	 * 
	 * @throws SQLException
	 *             if any connection problem encountered
	 */
	public static void cleanUp(Connection con, Statement stmt)  {

		try {
			if (stmt != null) {
				stmt.close();
				stmt = null;
			}
		} catch (Exception e) {
			System.out.println("On closing statement " + e);
		} finally {
			try {
				if (con != null) {
					con.close();
					con = null;
				}
			} catch (Exception e) {
				System.out.println("On closing connection " + e);
			}
		}

	}

	/**
	 * Common call for cleaning up Connection, Statement and Resultset which is
	 * currently opened.
	 * 
	 * @param con
	 *            Connection to close
	 * @param stmt
	 *            Statement to close
	 * @param rs
	 *            ResultSet to close
	 * 
	 * @throws SQLException
	 *             if any connection problem encountered
	 */
	public static void cleanUp(Connection con, Statement stmt, ResultSet rs)  {
		try {
			if (rs != null) {
				rs.close();
				rs = null;
			}
		} catch (Exception e) {
			System.out.println("On closing result set " + e);
		}
		cleanUp(con, stmt);
	}

	public static void cleanUp(Statement stmt, ResultSet rs)  {
		try {
			if (rs != null) {
				rs.close();
				rs = null;
			}
		} catch (Exception e) {
			System.out.println("On closing result set " + e);
		}

		try {
			if (stmt != null) {
				stmt.close();
				stmt = null;
			}
		} catch (Exception e) {
			System.out.println("On closing result set " + e);
		}

	}

	/**
	 * Common call for cleaning up Connection which is currently opened
	 * 
	 * @param con
	 *            to close
	 * 
	 * @throws SQLException
	 *             if any connection problem encountered
	 */
	public static void cleanUp(Connection con)  {
		try {
			if (con != null) {
				con.close();
			}
		} catch (Exception e) {
			System.out.println("On closing connection " + e);
		}
	}
}