package com.findlaypark.db.controller;


import java.util.Properties;


import javax.mail.Authenticator;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.PasswordAuthentication;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.AddressException;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;
import javax.mail.AuthenticationFailedException;

import org.apache.commons.configuration.Configuration;
import org.apache.commons.configuration.ConfigurationException;
import org.apache.commons.configuration.PropertiesConfiguration;


import com.findlaypark.utils.Utils;

public class MailController {
	
	
	public void sendMailWithPasswordReset(String to, String password) {
		
		try {
			String contents = Utils.readFile(this.getClass().getResource("/mail/passwordResetBody.txt").getFile());
			String subject = Utils.readFile(this.getClass().getResource("/mail/passwordResetSubject.txt").getFile());
			sendMail(subject, contents + " " + password, to);
			
			
		} catch(Exception e) {
			e.printStackTrace();
		}
		
	}
	
	public void sendMailAccountLocked(String to) {
		
		try {
			String contents = Utils.readFile(this.getClass().getResource("/mail/passwordResetBody.txt").getFile());
			String subject = Utils.readFile(this.getClass().getResource("/mail/passwordResetSubject.txt").getFile());
			sendMail(subject, contents, to);
			
			
		} catch(Exception e) {
			e.printStackTrace();
		}
		
	}
	

	public void sendMail(String subject, String message, String to) {
		Configuration config = null;

		
		
		try {
			
			config = new PropertiesConfiguration("mail/mail.properties");

			Properties props = new Properties();
			props.setProperty("mail.host", config.getString("mail.host"));
			props.setProperty("mail.smtp.port",	config.getString("mail.smtp.port"));
			props.setProperty("mail.smtp.auth",	config.getString("mail.smtp.auth"));
			props.setProperty("mail.smtp.starttls.enable",config.getString("mail.smtp.starttls.enable"));

			String login = config.getString("mail.login");
			String password = config.getString("mail.password");
			String from = config.getString("mail.sender.address");
			
			Authenticator auth = new SMTPAuthenticator(login, password);

			Session session = Session.getInstance(props, auth);

			MimeMessage msg = new MimeMessage(session);
			msg.setText(message);
			msg.setSubject(subject);
			msg.setFrom(new InternetAddress(from));
			msg.addRecipient(Message.RecipientType.TO, new InternetAddress(to));
			Transport.send(msg);
		} catch (ConfigurationException e) {
			e.printStackTrace();
		} catch (AuthenticationFailedException ex) {
			ex.printStackTrace();

		} catch (AddressException ex) {
			ex.printStackTrace();

		} catch (MessagingException ex) {
			ex.printStackTrace();
		}catch (Exception ex) {
			ex.printStackTrace();
		}

	}

	private class SMTPAuthenticator extends Authenticator {

		private PasswordAuthentication authentication;

		public SMTPAuthenticator(String login, String password) {
			authentication = new PasswordAuthentication(login, password);
		}

		protected PasswordAuthentication getPasswordAuthentication() {
			return authentication;
		}
	}
	
	public static void main(String [] args) {
		
		String subject = "Mail Test";
		String message = "Please find mail test";
		String to = "colin@openender.com";
		
		new MailController().sendMailWithPasswordReset(to, "eggnog");
	}

}
