package com.findlaypark.model;

import java.util.StringTokenizer;

public class AccessAddressController {

	
	public void checkIpAccessAddress(AuthenticationDetails auth, String currentIp) {
		String ipsSaved = auth.getUserData().getLastIps();
		if(ipsSaved == null) ipsSaved = "";
		if(ipsSaved.length() > (16 * 5)) {
			// its corrupted, best to clean it
			ipsSaved = "";
		}
		if(ipsSaved.length() > 0) {			
			auth.setUsedBeforeIp(ipsSaved.contains(currentIp));
			/** if it has'nt been used before - append it */
			if(!auth.isUsedBeforeIp()) {
				auth.getUserData().setLastIps(getUpatedIpString(ipsSaved, currentIp));
			}
		} else {
			/** ip not recorded, just set it to the current ip */
			auth.getUserData().setLastIps(currentIp);
		}
		
	}
	
	public String getUpatedIpString(String ipsSaved,  String currentIp) {
		
		if(currentIp == null) return ipsSaved;
		StringBuffer newIpList = new StringBuffer();
		StringTokenizer tk = new StringTokenizer(ipsSaved, " ");
		boolean deleteFirst = false;
		if(tk.countTokens() > 4) {			
			deleteFirst = true;				
		}			
		
		int count = 0;
		while(tk.hasMoreElements()) {
			String savedIp = tk.nextToken();
			if(count == 0 && deleteFirst) {
				newIpList.append(currentIp + " ");
			} else {
				newIpList.append(savedIp + " ");
			}
			count++;
		}
		if(!deleteFirst) newIpList.append(currentIp);
		return newIpList.toString().trim();
	}
	
	
}
