package com.findlaypark.model;

import com.findlaypark.pagenav.PageMetaDataFactory;

public class AuthenticationDetails {

	UserData userData;
	String ip;
	String parentIp;
	boolean passwordCorrect = false;
	boolean usedBeforeIp = false;
	
	
	public boolean isUsedBeforeIp() {
		return usedBeforeIp;
	}

	public void setUsedBeforeIp(boolean usedBeforeIp) {
		this.usedBeforeIp = usedBeforeIp;
	}

	public boolean isPasswordCorrect() {		
		return passwordCorrect;
	}

	public void setPasswordCorrect(boolean passwordValid) {
		this.passwordCorrect = passwordValid;
	}

	public AuthenticationDetails(String ip, String parentIp) {
		super();
		this.ip = ip;
		this.parentIp = parentIp;
	}
	
	public boolean isAccountLocked() {
		if(userData == null) return false;
		return userData.getPasswordLocked() == 1;
	}
	
	public UserData getUserData() {
		return userData;
	}
	
	public void setUserData(UserData userData) {
		this.userData = userData;
	}
	
	public boolean canAccessAdmin() {
		return userData != null && userData.getAdminAccess();
	}
	
	public boolean canAccessAmerican() {
		return userData != null && userData.getAmericanAccess();
	}
	
	public boolean canAccessLatin() {
		return userData != null && userData.getLatinAccess();
	}
	
	public boolean canAccessItem(String secureKey) {
		if(secureKey.equals(PageMetaDataFactory.ADMIN)) return canAccessAdmin();
		else if(secureKey.equals(PageMetaDataFactory.AMERICAN)) return canAccessAmerican();
		else if(secureKey.equals(PageMetaDataFactory.LATIN)) return canAccessLatin();
		else return false;
	}
	
	
	
	
}
