package com.findlaypark.pagenav;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.StringTokenizer;

import org.apache.commons.configuration.Configuration;
import org.apache.commons.lang.StringEscapeUtils;

public class PageMetaDataFactory {

	
	public static final String ADMIN = "Admin";
	public static final String AMERICAN = "American";
	public static final String LATIN = "Latin";
	
	
	public static final String SECURITY = "Security";
	public static final String HOME = "Home";
	
	public static final String MAIN_MENU = "Menu";
	public static final String QUOTE = getQuote();
	
	//public static final String MB = "MenuBarHorizontal";
	public static final String MB = "dropdown";
	//public static final String MBSub = "MenuBarItemSubmenu";
	public static final String MBSub = "sub_menu";
	
	
	public static final String MB_2 = "";
	
	public static String TOP_MENU = "TopMenu";	
	public static String BOTTOM_MENU = "BottomMenu";
	
	
	
	HashMap<String, PageMetaData> pageMetaDatas = new HashMap<String, PageMetaData>();
	ArrayList<String> topMenuNames = new ArrayList<String>();
	ArrayList<String> middleMenuNames = new ArrayList<String>();
	ArrayList<String> bottomMenusName = new ArrayList<String>();
	
	HashMap<String, Integer> securedPages = new HashMap<String, Integer>();
	
	StringBuffer htmlFirstMenuBuffer = null;
	StringBuffer htmlSecondMenuBuffer = null;
	StringBuffer htmlThirdMenuBuffer = null;
	
	Configuration config = null;
	String firstMenuString = null;
	String secondMenuString = null;
	String thirdMenuString = null;
	
	public String getFirstMenu() {				
		return firstMenuString;
	}
	
	public String getSecondMenu() {				
		return secondMenuString;
	}
	
	public String getThirdMenu() {				
		return thirdMenuString;
	}

	public PageMetaDataFactory(Configuration config, PageMetaData home, String currentSelected) {
		this.config = config;
		pageMetaDatas.put(HOME, home);
		createmetaData(currentSelected);	
	}
	
	private void createmetaData(String currentSelected) {
		
		String [] selectedMenus = getStringArray(currentSelected);
		String [] topMenusItems = config.getStringArray(TOP_MENU);
		String [] bottomMenusItems = config.getStringArray(BOTTOM_MENU);
		
		for(int i = 0; i < topMenusItems.length; i++) {
			PageMetaData meta = new PageMetaData();
			meta.setId('/' + topMenusItems[i]);
			meta.setDisplayName(topMenusItems[i]);
			meta.setMenuHref("/" + topMenusItems[i] );
			meta.setBody("/" + topMenusItems[i] + "/" + "body.jsp");
			meta.setHead("/page/pageHead.jsp");
			meta.setTail("/page/pageTail.jsp");
			meta.setSecureLevel("");		
			pageMetaDatas.put(meta.getId(), meta);
		}
		
		for(int i = 0; i < bottomMenusItems.length; i++) {
			PageMetaData meta = new PageMetaData();
			meta.setId('/' + bottomMenusItems[i]);
			meta.setDisplayName(bottomMenusItems[i]);
			meta.setMenuHref("/" + bottomMenusItems[i] );
			meta.setBody("/" + bottomMenusItems[i] + "/" + "body.jsp");
			meta.setHead("/page/pageHead.jsp");
			meta.setTail("/page/pageTail.jsp");
			meta.setSecureLevel("");		
			pageMetaDatas.put(meta.getId(), meta);
		}
		
		
		htmlFirstMenuBuffer = new StringBuffer();
		htmlSecondMenuBuffer = new StringBuffer();
		htmlThirdMenuBuffer = new StringBuffer();
		
		htmlFirstMenuBuffer.append("<ul id=" + QUOTE + "MenuBar1" + QUOTE +" class=" + QUOTE + MB + QUOTE + ">");
		htmlSecondMenuBuffer.append("<ul id=" + QUOTE + "MenuSubBar" + QUOTE + ">");
		htmlThirdMenuBuffer.append("<ul id=" + QUOTE + "MenuBar3" + QUOTE + ">");
		addCentreMenus(selectedMenus);		
		htmlFirstMenuBuffer.append("</ul>");
		htmlSecondMenuBuffer.append("</ul>");
		htmlThirdMenuBuffer.append("</ul>");
		
		firstMenuString = htmlFirstMenuBuffer.toString();
		secondMenuString = htmlSecondMenuBuffer.toString();
		thirdMenuString = htmlThirdMenuBuffer.toString();
		System.out.println(htmlFirstMenuBuffer.toString());
	}
	
	
	public void addCentreMenus(String [] selectedMenus) {
		String [] topMenus = getTopLevelMenus();
		int selectedSubMenu = 0;	
		for(int i = 0; i < topMenus.length; i++) {
				
			String [] secondLevelMenus = getSecondLevelMenus(topMenus[i]);
			int selectedMenu = 0;
			if(selectedMenus.length > 0) {
				if(selectedMenus[0].equals(topMenus[i])) {
					selectedMenu = 1;
				}
			}
			if(secondLevelMenus == null || secondLevelMenus.length == 0) {
				String secureKey = getSecuredKey(topMenus[i]);
				
				String link = getMenuLink(topMenus[i] , topMenus[i], selectedMenu, secureKey);				
				htmlFirstMenuBuffer.append(link);
			}
			else {
				String secureKey = getSecuredKey(topMenus[i]);
				htmlFirstMenuBuffer.append(getExpandableMenu(topMenus[i] , topMenus[i], selectedMenu, secureKey));
				/** Change for sub menu bar  
				  				 
				
				htmlTopLevelMenuBuffer.append(getMenuLink(toplevelMenus[i],toplevelMenus[i], selectedMenu, secureKey));
				*/
				htmlFirstMenuBuffer.append("<ul>");			
				
				for(int j = 0; j < secondLevelMenus.length; j++) {
					selectedSubMenu = 0;
					if(selectedMenu == 1) {
						if(selectedMenus.length > 1) {
							if(selectedMenus[1].equals(secondLevelMenus[j])) {
								selectedSubMenu = 2;
							}
						}
						
						htmlSecondMenuBuffer.append(getMenuLinkText(topMenus[i] + '/' + secondLevelMenus[j] , secondLevelMenus[j], selectedSubMenu, secureKey));
					}
					String [] thirdLevelMenus = getThirdLevelMenus(topMenus[i], secondLevelMenus[j]);
					if(thirdLevelMenus == null || thirdLevelMenus.length == 0) {
						secureKey = getSecuredKey(topMenus[i] + '.' + secondLevelMenus[j]);
						htmlFirstMenuBuffer.append(getMenuLink(topMenus[i] + '/' + secondLevelMenus[j] , secondLevelMenus[j], 0, secureKey));
						
						// this is a lineItem
					} else { 
						secureKey = getSecuredKey(topMenus[i] + '.' + secondLevelMenus[j]);
						htmlFirstMenuBuffer.append(getExpandableMenu(topMenus[i] + '/' + secondLevelMenus[j] ,secondLevelMenus[j], 0, secureKey));
						/** Change for sub menu bar  
						htmlTopLevelMenuBuffer.append(getMenuLink(toplevelMenus[i] + '/' + fundMenus[j] ,fundMenus[j], 0, secureKey));
						*/
						
						htmlFirstMenuBuffer.append("<ul>");
						
						for(int k = 0; k < thirdLevelMenus.length; k++) {
							secureKey = getSecuredKey(topMenus[i] + '.' + secondLevelMenus[j] + '.'+ thirdLevelMenus[k]);
							htmlFirstMenuBuffer.append(getMenuLink(topMenus[i] + '/' + secondLevelMenus[j] + '/'+ thirdLevelMenus[k], thirdLevelMenus[k],0, secureKey ));
							int selectedThirdMenu = 0;
							if(selectedMenu == 1 && selectedSubMenu == 2 && selectedMenus.length > 2) {
								if(selectedMenus[2].equals(thirdLevelMenus[k])) {
									selectedThirdMenu = 3;
								}
								htmlThirdMenuBuffer.append(getMenuLinkText(topMenus[i] + '/' + secondLevelMenus[j] + '/'+ thirdLevelMenus[k] , thirdLevelMenus[k], selectedThirdMenu, secureKey));
							}
							
						}
						htmlFirstMenuBuffer.append("</ul>");
						htmlFirstMenuBuffer.append("</li>");
					}
				}
				htmlFirstMenuBuffer.append("</ul>");
				htmlFirstMenuBuffer.append("</li>");
			}
			
		}
	}
	
	public String getExpandableMenu(String url, String name, int selectionId, String secureLevel) {
		PageMetaData meta = createMetaData(url, name, secureLevel);
		pageMetaDatas.put(meta.getId(), meta);
		System.out.println("Adding submenu " + name + " for " + " ID = " + meta.getId() + " href = " + meta.getMenuHref());
		return "<li><a class=" + QUOTE + MBSub + QUOTE + getSelection(selectionId) + " href=" + QUOTE +  "/" + url + QUOTE + ">" + stripUnderScore(name) + "</a>";
	}
	
	
	public String getMenuLink(String id, String name, int selectionId, String secureLevel) {		
		PageMetaData meta = createMetaData(id, name, secureLevel);
		pageMetaDatas.put(meta.getId(), meta);
		System.out.println("Adding " + name + " for " + " ID = " + meta.getId() + " href = " + meta.getMenuHref());
		return "<li><a" + getSelection(selectionId)+" href=" + QUOTE  + meta.getMenuHref() + QUOTE + ">" + stripUnderScore(name) + "</a></li>";
	}
	
	public String getMenuLinkText(String id, String name, int selectionId, String secureLevel) {		
		PageMetaData meta = createMetaData(id, name, secureLevel);
		pageMetaDatas.put(meta.getId(), meta);
		System.out.println("Adding " + name + " for " + " ID = " + meta.getId() + " href = " + meta.getMenuHref());
		if(selectionId > 0) return "<li" +  getSelection(selectionId) + ">" + stripUnderScore(name) + "</li>";
		return "<li><a" + getSelection(selectionId)+" href=" + QUOTE  + meta.getMenuHref() + QUOTE + ">" + stripUnderScore(name) + "</a></li>";
	}
	
	private PageMetaData createMetaData(String id, String name, String secureLevel) {
		PageMetaData meta = new PageMetaData();
		meta.setId('/' + id);
		meta.setDisplayName(name);
		meta.setMenuHref("/" + id );
		meta.setBody("/" + id + "/" + "body.jsp");
		meta.setHead("/page/pageHead.jsp");
		meta.setTail("/page/pageTail.jsp");		
		meta.setSecureLevel(secureLevel);	
		return meta;
	}
	
	private String getSelection(int selectionId) {	
		if(selectionId == 2) {
			return (selectionId > 0 ? ( " class=" + QUOTE + "selectedSubMenu2" + QUOTE + " id=" + QUOTE + "current" + selectionId + QUOTE) : "");
		} else if (selectionId == 3) {
			return (selectionId > 0 ? ( " class=" + QUOTE + "selectedSubMenu3" + QUOTE + " id=" + QUOTE + "current" + selectionId + QUOTE) : "");
		}
		
		return (selectionId > 0 ? ( " id=" + QUOTE + "current" + selectionId + QUOTE) : "");
	}
	
	public PageMetaData getPageMetaData(String key) {
		
		PageMetaData meta = pageMetaDatas.get(key);
		if(meta == null) {
			if(key.endsWith("/")) {
				meta = pageMetaDatas.get(key.substring(0, key.length() -1));
			}
			if(meta == null) {
				System.out.println("Unable to find page requested for " + key);
				meta = pageMetaDatas.get(HOME);
			}
		}
		return meta;
	}
	
	public String [] getTopLevelMenus() {		
		String [] menus = config.getStringArray(MAIN_MENU);
		return menus;
	}
	
	public String [] getSecondLevelMenus(String topMenuName) {
		String [] topMenus = config.getStringArray(MAIN_MENU + "." + topMenuName);
		return topMenus;
	}
	
	public String [] getThirdLevelMenus(String topMenuName, String secondLevelMenu) {
		String [] subMenus = config.getStringArray(MAIN_MENU + "." + topMenuName + "." + secondLevelMenu);
		return subMenus;
	}
	
	
	
	public static String getQuote() {
		return StringEscapeUtils.unescapeHtml("&quot;");
	}
	
	private String stripUnderScore(String word) {
		return word.replaceAll("_", " ");
	}
	
	private String [] getStringArray(String url) {
		ArrayList<String> strings = new ArrayList<String>();
		StringTokenizer t = new StringTokenizer(url, "/");
		while(t.hasMoreTokens()) {
			strings.add(t.nextToken());
		}
		return strings.toArray(new String []{});
	}
	
	public String getSecuredKey(String link) {
		String val = config.getString(SECURITY + "." + MAIN_MENU + "." + link);
		if(val != null ) {
			System.out.println("Setting security of " + val + " for " + link);
		} else {
			//System.out.println("Setting no security of " + link);
		}
		return val;
		
	}
	
}
