package com.findlaypark.service;

import java.sql.Connection;
import java.util.Date;

import com.findlaypark.db.controller.DataController;
import com.findlaypark.db.controller.MailController;
import com.findlaypark.model.AccessAddressController;
import com.findlaypark.model.AuthenticationDetails;
import com.findlaypark.model.PasswordGenerator;
import com.findlaypark.model.UserData;
import com.findlaypark.utils.Utils;
import com.findlaypark.web.DataBaseConnectionHandler;

public class LoginService {
	DataBaseConnectionHandler connectionHandler = null;
	
	public LoginService(DataBaseConnectionHandler connectionHandler) {
		this.connectionHandler = connectionHandler;
	}
	
	public AuthenticationDetails login(String userName, String password, String ip, String parentIp) throws Exception {
		AuthenticationDetails details = null;
		
		if(password != null && !password.equals("")) {
			details = new AuthenticationDetails(ip, parentIp);
			Connection con = connectionHandler.getConnection();
			UserData userData = new DataController().getUserDataDB(con, userName);
			details.setUserData(userData);
			if(userData != null) {
				try {
					System.out.println("User " + userData.getEmail() + " logging in - last access was " + userData.getLastAccessDate() != null && userData.getLastAccessDate().length() > 0 ? new Date(Long.parseLong(userData.getLastAccessDate())).toGMTString() : userData.getLastAccessDate());
				} catch(Exception e) {					
					System.out.println("User " + userData.getEmail() + " logging in - last access was " + userData.getLastAccessDate());					
				}
				details.setPasswordCorrect(userData.getPassword().equals(password));
				if(details.isPasswordCorrect()) {
					if(userData.getPasswordLocked() == 1) {
						userData.setLastAccessDate(Utils.getDateString(new Date()));
						new AccessAddressController().checkIpAccessAddress(details, ip);
						System.out.println("Ip Adress check - IP used before = " + details.isUsedBeforeIp());
						con = connectionHandler.getConnection();
						new DataController().updateUserData(con, userData);
					} else {
						
						/** password is not valid, account is locked */
					}
				}
			}
			details.setUserData(userData);
		}
		return details;
	}
	
	public UserData getUserNoLogin(String userName)  throws Exception{		
		Connection con = connectionHandler.getConnection();
		UserData userData = new DataController().getUserDataDB(con, userName);
		return userData;
	}
	
	public void resetPassword(UserData userData) throws Exception {
		Connection con = connectionHandler.getConnection();		
		userData.setPassword(PasswordGenerator.getRandomPassword());
		userData.setPasswordValid(1);
		System.out.println("Reset password to " + userData.getPassword());
		new DataController().updateUserData(con, userData);
		new MailController().sendMailWithPasswordReset(userData.getEmail(), userData.getPassword());
	}
	
}
