package com.findlaypark.utils;

import java.io.File;
import java.io.FileNotFoundException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Scanner;

public class Utils {

	public static String nonNullString(String string) {
		if (string == null || string.equals("null"))
			return "";
		return string;
	}

	public static String getDateString(Date date) {
		return new SimpleDateFormat().format(date);
	}

	public static String readFile(String fileName) throws FileNotFoundException {
		File file = new File(fileName);
		StringBuilder fileContents = new StringBuilder((int) file.length());
		Scanner scanner = new Scanner(file);
		String lineSeparator = System.getProperty("line.separator");

		try {
			while (scanner.hasNextLine()) {
				fileContents.append(scanner.nextLine() + lineSeparator);
			}
			return fileContents.toString();
		} finally {
			scanner.close();
		}
	}
}
