package com.findlaypark.web;

import java.io.File;
import java.util.Date;
import java.util.Timer;
import java.util.TimerTask;

import javax.servlet.ServletContext;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

import com.findlaypark.lock.PublishContentLock;

public class ServletContextTimer implements ServletContextListener {
	ServletContext servletContext;

	long id = new Date().getTime();

	public volatile boolean isLocked = false;
	private final PublishContentLock lock = new PublishContentLock();
	
	/* Methods from the ServletContextListener */
	public void contextInitialized(ServletContextEvent sce) {
		servletContext = sce.getServletContext();

		System.out.println("Starting ServletContextTimer " + id);

		int delay = 651100;
		Timer timer = new Timer();
		
		timer.scheduleAtFixedRate(new TimerTask() {
			public void run() {
				
				System.out.println(id + "Running Upload Task");
				File f = new File("c:\\fp\\staging");
				if(f.exists()) {
					try {
						
						System.out.println("staging exists");
						lock.getLock();
						System.out.println("got Lock");
						System.out.println(servletContext.getRealPath(File.separator));
						File current = new File(servletContext.getRealPath(File.separator) + "/Latin_American_Fund");
						System.out.println(current.getPath()+ " exists " + current.exists());
					} catch(Exception e) {
						
					} finally {
						lock.relaseLock();
						System.out.println("released Lock");
					}
					
				} else {
					System.out.println("staging no exists");
				}
			}
		}, delay, delay);
		servletContext.setAttribute("timer", timer);
		servletContext.setAttribute("publishLock", lock);
	}

	public void contextDestroyed(ServletContextEvent sce) {
		System.out.println("Stopping ServletContextTimer " + id);
		ServletContext servletContext = sce.getServletContext();
		// get our timer from the Context
		Timer timer = (Timer)servletContext.getAttribute ("timer");

		// cancel all pending tasks in the timers queue
		if (timer != null)
		timer.cancel();

		// remove the timer from the servlet context
		servletContext.removeAttribute ("timer");
	}

	protected void log(String msg) {
		System.out.println("[" + getClass().getName() + "] " + msg);
	}

}
