package com.findlaypark.unittests.userdata;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.junit.runners.Suite;
import org.junit.runners.Suite.SuiteClasses;

import com.findlaypark.model.AccessAddressController;
import static org.junit.Assert.assertEquals;


public class AllTests {

	
	@Test
	public void testNewIps() {
		AccessAddressController ac = new AccessAddressController();
		
		String ipsSaved = "";
		String currentIp = "0.0.0.0";
		
		String res = ac.getUpatedIpString(ipsSaved, currentIp);
		
		assertEquals(res, currentIp);
	}
	
	
	@Test
	public void addNewIps() {
		AccessAddressController ac = new AccessAddressController();
		
		String ipsSaved = "127.0.0.0";
		String currentIp = "0.0.0.0";
		
		String res = ac.getUpatedIpString(ipsSaved, currentIp);
		
		assertEquals(res, "127.0.0.0" + " " + "0.0.0.0");
	}
	
	@Test
	public void addMaxIps() {
		AccessAddressController ac = new AccessAddressController();
		
		String ipsSaved = "127.0.0.0 126.0.0.0 125.0.0.0 124.0.0.0";
		String currentIp = "0.0.0.0";
		
		String res = ac.getUpatedIpString(ipsSaved, currentIp);
		
		assertEquals(res, "127.0.0.0 126.0.0.0 125.0.0.0 124.0.0.0" + " " + "0.0.0.0");
	}
	
	@Test
	public void addMaxReplaceIps() {
		AccessAddressController ac = new AccessAddressController();
		
		String ipsSaved = "127.0.0.0 126.0.0.0 125.0.0.0 124.0.0.0 123.0.0.0";
		String currentIp = "0.0.0.0";
		
		String res = ac.getUpatedIpString(ipsSaved, currentIp);
		
		assertEquals(res, "0.0.0.0 126.0.0.0 125.0.0.0 124.0.0.0 123.0.0.0");
	}
	
}
